'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _warning = require('warning');

var _warning2 = _interopRequireDefault(_warning);

var _TableRow = require('./TableRow');

var _TableRow2 = _interopRequireDefault(_TableRow);

var _TableRowColumn = require('./TableRowColumn');

var _TableRowColumn2 = _interopRequireDefault(_TableRowColumn);

var _TextField = require('material-ui/TextField');

var _TextField2 = _interopRequireDefault(_TextField);

var _IconButton = require('material-ui/IconButton');

var _IconButton2 = _interopRequireDefault(_IconButton);

var _RaisedButton = require('material-ui/RaisedButton');

var _RaisedButton2 = _interopRequireDefault(_RaisedButton);

var _add = require('material-ui/svg-icons/content/add');

var _add2 = _interopRequireDefault(_add);

var _contentCopy = require('material-ui/svg-icons/content/content-copy');

var _contentCopy2 = _interopRequireDefault(_contentCopy);

var _delete = require('material-ui/svg-icons/action/delete');

var _delete2 = _interopRequireDefault(_delete);

var _Dialog = require('material-ui/Dialog');

var _Dialog2 = _interopRequireDefault(_Dialog);

var _FlatButton = require('material-ui/FlatButton');

var _FlatButton2 = _interopRequireDefault(_FlatButton);

var _TableDataStore = require('./TableDataStore');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function getStyles(props, context) {
  var _context$muiTheme = context.muiTheme,
      baseTheme = _context$muiTheme.baseTheme,
      table = _context$muiTheme.table;


  return {
    root: {
      backgroundColor: table.backgroundColor,
      width: '100%',
      borderCollapse: 'collapse',
      borderSpacing: 0,
      tableLayout: 'fixed',
      fontFamily: baseTheme.fontFamily
    },
    bodyTable: {
      height: props.fixedHeader || props.fixedFooter ? props.height : 'auto',
      overflowX: 'hidden',
      overflowY: 'auto'
    },
    tableWrapper: {
      height: props.fixedHeader || props.fixedFooter ? 'auto' : props.height,
      overflow: 'auto'
    }
  };
}

var Table = function (_Component) {
  _inherits(Table, _Component);

  function Table(props) {
    _classCallCheck(this, Table);

    //获取数据表的数据源
    var _this = _possibleConstructorReturn(this, (Table.__proto__ || Object.getPrototypeOf(Table)).call(this, props));

    _initialiseProps.call(_this);

    var datas = _this.getTableDatas(_this.props.children);
    //初始化工具类
    _this.store = new _TableDataStore.TableDataStore(datas);
    //列对象
    _this.dataFields = _this.getTableDataFields(_this.props.children);

    _this.state = {
      allRowsSelected: false,
      datas: datas,
      selectedRows: _this.props.selectedRows ? _this.props.selectedRows : [],
      selectedDatas: []
    };
    return _this;
  }

  _createClass(Table, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      //获取数据表的数据源
      var datas = this.getTableDatas(nextProps.children);
      //初始化工具类
      this.store = new _TableDataStore.TableDataStore(datas);
      //列对象
      this.dataFields = this.getTableDataFields(nextProps.children);
      //判断是否传入选项
      if (nextProps.selectedRows) {
        this.setState({
          selectedRows: nextProps.selectedRows,
          selectedDatas: nextProps.selectedDatas
        });
      };

      this.setState({
        datas: datas
      });
    }
  }, {
    key: 'getTableDatas',


    /**
     * 初始化数据
     * @param  {[type]} base [description]
     * @return {[type]}      [description]
     */
    value: function getTableDatas(base) {
      var datas = [];
      _react2.default.Children.map(base, function (child, index) {
        var muiName = child.type.muiName;

        if (muiName === 'TableBody') {
          datas = child.props.datas;
        }
      });
      return datas;
    }

    /**
     * 获取表格表头属性
     * @param  {[type]} base [description]
     * @return {[type]}      [description]
     */

  }, {
    key: 'getTableDataFields',
    value: function getTableDataFields(base) {
      var tableHeader = void 0;
      var dataField = [];
      _react2.default.Children.map(base, function (child, index) {
        var muiName = child.type.muiName;

        if (muiName === 'TableHeader') {
          tableHeader = child.props.children.props;
        }
      });

      if (!tableHeader) return;

      var columnRows = tableHeader.children;

      if (columnRows.length) {
        columnRows.map(function (item, index) {
          dataField.push({
            dataField: item.props.dataField, //列表字段
            dataFieldName: item.props.children, //列表字段名称
            dataFormat: item.props.dataFormat, //格式化字段
            edit: item.props.edit, //是否编辑
            customEditor: item.props.customEditor,
            onChange: item.props.onChange
          });
        });
      } else {
        dataField.push({
          dataField: columnRows.props.dataField, //列表字段
          dataFieldName: columnRows.props.children, //列表字段名称
          dataFormat: columnRows.props.dataFormat, //格式化字段
          edit: columnRows.props.edit, //是否编辑
          customEditor: columnRows.props.customEditor,
          onChange: columnRows.props.onChange
        });
      }
      return dataField;
    }
  }, {
    key: 'componentWillMount',
    value: function componentWillMount() {
      if (this.props.allRowsSelected) {
        this.setState({ allRowsSelected: true });
      }
    }
  }, {
    key: 'isScrollbarVisible',
    value: function isScrollbarVisible() {
      var tableDivHeight = this.refs.tableDiv.clientHeight;
      var tableBodyHeight = this.refs.tableBody.clientHeight;

      return tableBodyHeight > tableDivHeight;
    }
  }, {
    key: 'createTableHeader',
    value: function createTableHeader(base) {
      return _react2.default.cloneElement(base, {
        enableSelectAll: base.props.enableSelectAll && this.props.selectable && this.props.multiSelectable,
        onSelectAll: this.onSelectAll,
        selectAllSelected: this.state.allRowsSelected,
        onClickHeader: this.props.onClickHeader
      });
    }

    /**
     * 创建数据主体
     * @return {[type]} [description]
     */

  }, {
    key: 'createTableBodyElement',
    value: function createTableBodyElement(tHeadData) {
      var _this2 = this;

      var datas = this.state.datas;
      return datas.map(function (row, index) {
        return _react2.default.createElement(
          _TableRow2.default,
          { key: index },
          _this2.dataFields.map(function (item, index) {
            var style = {};
            var styles = void 0;
            if (_react2.default.isValidElement(tHeadData)) {
              styles = tHeadData.props.style;
            } else {
              styles = tHeadData[index].props.style;
            }

            if (styles) {
              var _styles = styles,
                  width = _styles.width,
                  height = _styles.height,
                  paddingLeft = _styles.paddingLeft,
                  paddingRight = _styles.paddingRight;


              if (width) {
                style['width'] = width;
              }

              if (height) {
                style['height'] = height;
              }

              if (paddingLeft) {
                style['paddingLeft'] = paddingLeft;
              }

              if (paddingRight) {
                style['paddingRight'] = paddingRight;
              }
            }
            var dataFormat = item.dataFormat,
                dataField = item.dataField,
                edit = item.edit,
                onChange = item.onChange;

            var columnValue = void 0;

            if (dataFormat && typeof dataFormat === 'function') {
              columnValue = _react2.default.cloneElement(dataFormat(row[dataField], { _row: row }));
            } else {
              columnValue = row[dataField];
            }
            return _react2.default.createElement(
              _TableRowColumn2.default,
              { onChange: onChange, style: style, edit: edit, key: index, dataField: dataField },
              columnValue
            );
          })
        );
      });
    }
  }, {
    key: 'createTableBody',
    value: function createTableBody(base, tHeadData) {
      var tableRow = this.createTableBodyElement(tHeadData);

      return _react2.default.cloneElement(base, {
        allRowsSelected: this.state.allRowsSelected,
        multiSelectable: this.props.multiSelectable,
        onCellClick: this.onCellClick,
        onCellHover: this.onCellHover,
        onCellHoverExit: this.onCellHoverExit,
        onRowHover: this.onRowHover,
        onRowHoverExit: this.onRowHoverExit,
        onRowSelection: this.onRowSelection,
        selectable: this.props.selectable,
        style: Object.assign({ height: this.props.height }, base.props.style),
        cellEdit: this.cellEdit,
        selectedRows: this.state.selectedRows,
        onClickSelected: this.onClickSelected,
        isClickSelected: this.props.onClickSelected ? true : false,
        clickSelected: this.props.clickSelected
      }, tableRow);
    }
  }, {
    key: 'createTableFooter',
    value: function createTableFooter(base) {
      return base;
    }

    /**
     * 
     * @param  {[type]} rowNumber    [description]
     * @param  {[type]} columnNumber [description]
     * @param  {[type]} event        [description]
     * @return {[type]}              [description]
     */

  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _props = this.props,
          children = _props.children,
          className = _props.className,
          fixedFooter = _props.fixedFooter,
          fixedHeader = _props.fixedHeader,
          style = _props.style,
          wrapperStyle = _props.wrapperStyle,
          headerStyle = _props.headerStyle,
          bodyStyle = _props.bodyStyle,
          footerStyle = _props.footerStyle,
          id = _props.id,
          contentClassName = _props.contentClassName,
          contentId = _props.contentId;
      var prepareStyles = this.context.muiTheme.prepareStyles;

      var styles = getStyles(this.props, this.context);

      var tHead = void 0;
      var tFoot = void 0;
      var tBody = void 0;

      var tHeadData = void 0;

      _react2.default.Children.forEach(children, function (child) {
        if (!_react2.default.isValidElement(child)) return;
        var muiName = child.type.muiName;


        if (muiName === 'TableHeader') {
          tHeadData = child.props.children.props.children;
        }
      });

      _react2.default.Children.forEach(children, function (child) {
        if (!_react2.default.isValidElement(child)) return;

        var muiName = child.type.muiName;

        if (muiName === 'TableBody') {
          tBody = _this3.createTableBody(child, tHeadData);
        } else if (muiName === 'TableHeader') {
          tHead = _this3.createTableHeader(child);
        } else if (muiName === 'TableFooter') {
          tFoot = _this3.createTableFooter(child);
        } else {
          (0, _warning2.default)(false, 'Material-UI: Children of the Table component must be TableBody or TableHeader or TableFooter.\n           Nothing is rendered.');
        }
      });

      // If we could not find a table-header and a table-body, do not attempt to display anything.
      if (!tBody && !tHead) return null;

      var mergedTableStyle = Object.assign(styles.root, style);
      var headerTable = void 0;
      var footerTable = void 0;
      var inlineHeader = void 0;
      var inlineFooter = void 0;

      if (fixedHeader) {
        headerTable = _react2.default.createElement(
          'div',
          { style: prepareStyles(Object.assign({}, headerStyle)) },
          _react2.default.createElement(
            'table',
            { className: className, style: mergedTableStyle },
            tHead
          )
        );
      } else {
        inlineHeader = tHead;
      }

      if (tFoot !== undefined) {
        if (fixedFooter) {
          footerTable = _react2.default.createElement(
            'div',
            { style: prepareStyles(Object.assign({}, footerStyle)) },
            _react2.default.createElement(
              'table',
              { className: className, style: prepareStyles(mergedTableStyle) },
              tFoot
            )
          );
        } else {
          inlineFooter = tFoot;
        }
      }

      var operate = void 0;
      if (this.props.operate) {

        operate = _react2.default.createElement(Operate, {
          dataFields: this.dataFields,
          handleSubmit: this.props.handleSubmit,
          onRowDel: this.onRowDel,
          onRowAdd: this.props.onRowAdd,
          onRowCopy: this.onRowCopy,
          actions: this.props.actions,
          getContent: this.props.getContent,
          open: this.props.open,
          options: this.props.operate.options,
          handleDialogClose: this.props.handleDialogClose,
          style: this.props.operateStyle,
          dialogStyle: this.props.dialogStyle,
          dialogIconElement: this.props.dialogIconElement });
      }

      return _react2.default.createElement(
        'div',
        { id: id, style: prepareStyles(Object.assign(styles.tableWrapper, wrapperStyle)) },
        operate,
        headerTable,
        _react2.default.createElement(
          'div',
          { id: contentId, className: contentClassName, style: prepareStyles(Object.assign(styles.bodyTable, bodyStyle)), ref: 'tableDiv' },
          _react2.default.createElement(
            'table',
            { className: className, style: mergedTableStyle, ref: 'tableBody' },
            inlineHeader,
            inlineFooter,
            tBody
          )
        ),
        footerTable
      );
    }
  }]);

  return Table;
}(_react.Component);

Table.propTypes = {
  /**
   * Set to true to indicate that all rows should be selected.
   */
  allRowsSelected: _react.PropTypes.bool,
  /**
   * Override the inline-styles of the body's table element.
   */
  bodyStyle: _react.PropTypes.object,
  /**
   * Children passed to table.
   */
  children: _react.PropTypes.node,
  /**
   * The css class name of the root element.
   */
  className: _react.PropTypes.string,
  /**
   * If true, the footer will appear fixed below the table.
   * The default value is true.
   */
  fixedFooter: _react.PropTypes.bool,
  /**
   * If true, the header will appear fixed above the table.
   * The default value is true.
   */
  fixedHeader: _react.PropTypes.bool,
  /**
   * Override the inline-styles of the footer's table element.
   */
  footerStyle: _react.PropTypes.object,
  /**
   * Override the inline-styles of the header's table element.
   */
  headerStyle: _react.PropTypes.object,
  /**
   * The height of the table.
   */
  height: _react.PropTypes.string,
  /**
   * If true, multiple table rows can be selected.
   * CTRL/CMD+Click and SHIFT+Click are valid actions.
   * The default value is false.
   */
  multiSelectable: _react.PropTypes.bool,
  /**
   * Called when a row cell is clicked.
   * rowNumber is the row number and columnId is
   * the column number or the column key.
   */
  onCellClick: _react.PropTypes.func,
  /**
   * Called when a table cell is hovered.
   * rowNumber is the row number of the hovered row
   * and columnId is the column number or the column key of the cell.
   */
  onCellHover: _react.PropTypes.func,
  /**
   * Called when a table cell is no longer hovered.
   * rowNumber is the row number of the row and columnId
   * is the column number or the column key of the cell.
   */
  onCellHoverExit: _react.PropTypes.func,
  /**
   * Called when a table row is hovered.
   * rowNumber is the row number of the hovered row.
   */
  onRowHover: _react.PropTypes.func,
  /**
   * Called when a table row is no longer hovered.
   * rowNumber is the row number of the row that is no longer hovered.
   */
  onRowHoverExit: _react.PropTypes.func,
  /**
   * Called when a row is selected.
   * selectedRows is an array of all row selections.
   * IF all rows have been selected, the string "all"
   * will be returned instead to indicate that all rows have been selected.
   */
  onRowSelection: _react.PropTypes.func,
  /**
   * If true, table rows can be selected.
   * If multiple row selection is desired, enable multiSelectable.
   * The default value is true.
   */
  selectable: _react.PropTypes.bool,
  /**
   * Override the inline-styles of the root element.
   */
  style: _react.PropTypes.object,
  /**
   * Override the inline-styles of the table's wrapper element.
   */
  wrapperStyle: _react.PropTypes.object
};
Table.defaultProps = {
  allRowsSelected: false,
  fixedFooter: true,
  fixedHeader: true,
  height: 'inherit',
  multiSelectable: false,
  selectable: true,
  dialogStyle: {
    bodyClassName: '',
    bodyStyle: {},
    contentStyle: {},
    titleStyle: {},
    titleClassName: '',
    actionsContainerClassName: '',
    actionsContainerStyle: {}

  }
};
Table.contextTypes = {
  muiTheme: _react.PropTypes.object.isRequired
};

var _initialiseProps = function _initialiseProps() {
  var _this7 = this;

  this.onClickSelected = function (rowNumber, columnNumber, event) {
    var datas = _this7.store.getDatasByRows([rowNumber]);
    if (_this7.props.onClickSelected) _this7.props.onClickSelected(rowNumber, datas);
  };

  this.onCellClick = function (rowNumber, columnNumber, event) {
    if (_this7.props.onCellClick) _this7.props.onCellClick(rowNumber, columnNumber, event);
  };

  this.onCellHover = function (rowNumber, columnNumber, event) {
    if (_this7.props.onCellHover) _this7.props.onCellHover(rowNumber, columnNumber, event);
  };

  this.onCellHoverExit = function (rowNumber, columnNumber, event) {
    if (_this7.props.onCellHoverExit) _this7.props.onCellHoverExit(rowNumber, columnNumber, event);
  };

  this.onRowHover = function (rowNumber) {
    if (_this7.props.onRowHover) _this7.props.onRowHover(rowNumber);
  };

  this.onRowHoverExit = function (rowNumber) {
    if (_this7.props.onRowHoverExit) _this7.props.onRowHoverExit(rowNumber);
  };

  this.onRowSelection = function (selectedRows) {
    //查找
    var datas = _this7.store.getDatasByRows(selectedRows);
    _this7.setState({
      selectedRows: selectedRows,
      selectedDatas: datas
    });

    if (_this7.state.allRowsSelected) _this7.setState({ allRowsSelected: false });
    if (_this7.props.onRowSelection) _this7.props.onRowSelection(selectedRows, datas);
  };

  this.onSelectAll = function () {
    if (_this7.props.onRowSelection) {
      if (!_this7.state.allRowsSelected) {
        _this7.props.onRowSelection('all');
      } else {
        _this7.props.onRowSelection('none');
      }
    }
    _this7.setState({ allRowsSelected: !_this7.state.allRowsSelected });
  };

  this.cellEdit = function (row, dataField, value) {
    var store = _this7.store.cellEdit(row, dataField, value);
    _this7.props.onCellEdit(store.datas[row]);
    _this7.setState({
      datas: store.datas
    });
  };

  this.onRowDel = function () {
    // this.setState({
    //   selectedRows: [],
    // })
    _this7.props.onRowDel(_this7.state.selectedDatas, _this7.state.selectedRows);
  };

  this.onRowCopy = function () {
    if (_this7.props.onRowCopy) {
      _this7.props.onRowCopy(_this7.state.selectedDatas);
    }
  };

  this.onTest = function () {
    console.log('调用父级的方法');
  };
};

exports.default = Table;

/**
 * 操作
 */

var Operate = function (_React$Component) {
  _inherits(Operate, _React$Component);

  function Operate(props) {
    _classCallCheck(this, Operate);

    var _this4 = _possibleConstructorReturn(this, (Operate.__proto__ || Object.getPrototypeOf(Operate)).call(this, props));

    _this4.handleOnDel = function () {
      if (_this4.props.onRowDel) {
        _this4.props.onRowDel();
      }
    };

    _this4.handleOnAdd = function () {
      if (_this4.props.onRowAdd) {
        _this4.props.onRowAdd();
      }
    };

    _this4.handleOnCopy = function () {
      if (_this4.props.onRowCopy) {
        _this4.props.onRowCopy();
      }
    };

    return _this4;
  }

  _createClass(Operate, [{
    key: 'render',
    value: function render() {
      var _this5 = this;

      var actions = [];

      var options = this.props.options;

      if (options) {
        options.map(function (item, index) {
          if (item === 'add') {
            actions.push(_react2.default.createElement(
              _IconButton2.default,
              { key: index, onTouchTap: _this5.handleOnAdd },
              _react2.default.createElement(_add2.default, null)
            ));
          }
          if (item === 'copy') {
            actions.push(_react2.default.createElement(
              _IconButton2.default,
              { key: index, onTouchTap: _this5.handleOnCopy },
              _react2.default.createElement(_contentCopy2.default, null)
            ));
          }
          if (item === 'del') {
            actions.push(_react2.default.createElement(
              _IconButton2.default,
              { key: index, onTouchTap: _this5.handleOnDel },
              _react2.default.createElement(_delete2.default, null)
            ));
          }
        });
      }

      return _react2.default.createElement(
        'div',
        { style: Object.assign({}, { position: 'relative', display: 'inline-block', float: 'right' }, this.props.style) },
        actions,
        _react2.default.createElement(AddDataDialog, {
          open: this.props.open,
          handleDialogClose: this.props.handleDialogClose,
          dataFields: this.props.dataFields,
          handleSubmit: this.props.handleSubmit,
          actions: this.props.actions,
          getContent: this.props.getContent,
          bodyClassName: this.props.dialogStyle.bodyClassName,
          bodyStyle: this.props.dialogStyle.bodyStyle,
          contentStyle: this.props.dialogStyle.contentStyle,
          titleStyle: this.props.dialogStyle.titleStyle,
          titleClassName: this.props.dialogStyle.titleClassName,
          actionsContainerClassName: this.props.dialogStyle.actionsContainerClassName,
          actionsContainerStyle: this.props.dialogStyle.actionsContainerStyle,
          iconElement: this.props.dialogIconElement
        })
      );
    }
  }]);

  return Operate;
}(_react2.default.Component);

/**
 * 编辑的dailog
 */


var AddDataDialog = function (_React$Component2) {
  _inherits(AddDataDialog, _React$Component2);

  function AddDataDialog(props) {
    _classCallCheck(this, AddDataDialog);

    var _this6 = _possibleConstructorReturn(this, (AddDataDialog.__proto__ || Object.getPrototypeOf(AddDataDialog)).call(this, props));

    _this6.handleDialogClose = function () {
      _this6.props.handleDialogClose();
    };

    _this6.handleSubmit = function (event) {
      _this6.handleDialogClose();
    };

    _this6.handleOnChange = function (event, newsValue, stateName) {
      var data = {};
      data[stateName] = newsValue;
      _this6.setState(data);
    };

    _this6.state = {};
    return _this6;
  }

  /**
   * 关闭窗口
   * @return {[type]} [description]
   */


  /**
   * 提交数据
   * @param  {[type]} event [description]
   * @return {[type]}       [description]
   */


  /**
   * 
   * @param  {[type]} event     [description]
   * @param  {[type]} newsValue [description]
   * @param  {[type]} stateName [description]
   * @return {[type]}           [description]
   */


  _createClass(AddDataDialog, [{
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          _Dialog2.default,
          {
            title: '\u6DFB\u52A0\u4FE1\u606F',
            modal: false,
            bodyClassName: this.props.bodyClassName,
            bodyStyle: this.props.bodyStyle,
            contentStyle: this.props.contentStyle,
            titleStyle: this.props.titleStyle,
            titleClassName: this.props.titleClassName,
            actionsContainerClassName: this.props.actionsContainerClassName,
            actionsContainerStyle: this.props.actionsContainerStyle,
            style: { marginTop: -100 },
            open: this.props.open,
            onRequestClose: this.handleDialogClose,
            actions: this.props.actions },
          this.props.iconElement,
          !this.props.getContent ? [] : this.props.getContent()
        )
      );
    }
  }]);

  return AddDataDialog;
}(_react2.default.Component);