'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _TextField = require('material-ui/TextField');

var _TextField2 = _interopRequireDefault(_TextField);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function getStyles(props, context) {
  var tableRowColumn = context.muiTheme.tableRowColumn;


  var styles = {
    root: {
      paddingLeft: tableRowColumn.spacing,
      paddingRight: tableRowColumn.spacing,
      height: tableRowColumn.height,
      textAlign: 'left',
      fontSize: 13,
      overflow: 'hidden',
      whiteSpace: 'nowrap',
      textOverflow: 'ellipsis'
    }
  };

  if (_react2.default.Children.count(props.children) === 1 && !isNaN(props.children)) {
    styles.textAlign = 'right';
  }

  return styles;
}

var TableRowColumn = function (_Component) {
  _inherits(TableRowColumn, _Component);

  function TableRowColumn() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, TableRowColumn);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = TableRowColumn.__proto__ || Object.getPrototypeOf(TableRowColumn)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      hovered: false,
      isEdit: false //是否编辑
    }, _this.onClick = function (event) {
      if (!_this.props.isClickSelected) return false;
      if (!event.currentTarget.querySelector('input[type=checkbox]')) {
        _this.props.setClickSelected(_this.props.rowNumber, _this.props.columnNumber, event);
      }
    }, _this.onMouseEnter = function (event) {
      if (_this.props.hoverable) {
        _this.setState({
          hovered: true
        });
        if (_this.props.onHover) {
          _this.props.onHover(event, _this.props.columnNumber);
        }
      }
    }, _this.onMouseLeave = function (event) {
      if (_this.props.hoverable) {
        _this.setState({
          hovered: false
        });
        if (_this.props.onHoverExit) {
          _this.props.onHoverExit(event, _this.props.columnNumber);
        }
      }
    }, _this.onDoubleClick = function () {
      if (_this.props.edit) {
        _this.setState({
          isEdit: true
        });
      }
    }, _this.handleOnBlur = function (value) {
      _this.setState({
        isEdit: false
      }, function () {
        _this.props.cellEdit(_this.props.rowNumber, _this.props.dataField, value);
      });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  /**
   * 双击编辑
   * @return {[type]} [description]
   */


  /**
   * 失去焦点事件
   * @param  {[type]} value [description]
   * @return {[type]}       [description]
   */


  _createClass(TableRowColumn, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          className = _props.className,
          columnNumber = _props.columnNumber,
          hoverable = _props.hoverable,
          onClick = _props.onClick,
          onHover = _props.onHover,
          onHoverExit = _props.onHoverExit,
          style = _props.style,
          rowNumber = _props.rowNumber,
          edit = _props.edit,
          cellEdit = _props.cellEdit,
          dataField = _props.dataField,
          setClickSelected = _props.setClickSelected,
          onClickSelected = _props.onClickSelected,
          isClickSelected = _props.isClickSelected,
          onChange = _props.onChange,
          other = _objectWithoutProperties(_props, ['children', 'className', 'columnNumber', 'hoverable', 'onClick', 'onHover', 'onHoverExit', 'style', 'rowNumber', 'edit', 'cellEdit', 'dataField', 'setClickSelected', 'onClickSelected', 'isClickSelected', 'onChange']);

      var prepareStyles = this.context.muiTheme.prepareStyles;

      var styles = getStyles(this.props, this.context);

      var handlers = {
        onClick: this.onClick,
        onMouseEnter: this.onMouseEnter,
        onMouseLeave: this.onMouseLeave,
        onDoubleClick: this.onDoubleClick
      };

      /**
       * 根据当前是否是编辑状态
       */
      var element = void 0;

      var childrenValue = children === null ? '' : children;
      if (this.state.isEdit && !_react2.default.isValidElement(children)) {
        element = _react2.default.createElement(EditTextField, { onChange: onChange, handleOnBlur: this.handleOnBlur, value: childrenValue });
      } else {
        element = childrenValue;
      }

      return _react2.default.createElement(
        'td',
        _extends({
          className: className,
          style: prepareStyles(Object.assign(styles.root, style, { cursor: this.props.isClickSelected ? 'pointer' : 'default' }))
        }, handlers, other),
        element
      );
    }
  }]);

  return TableRowColumn;
}(_react.Component);

TableRowColumn.muiName = 'TableRowColumn';
TableRowColumn.propTypes = {
  children: _react.PropTypes.node,
  /**
   * The css class name of the root element.
   */
  className: _react.PropTypes.string,
  /**
   * @ignore
   * Number to identify the header row. This property
   * is automatically populated when used with TableHeader.
   */
  columnNumber: _react.PropTypes.number,
  /**
   * @ignore
   * If true, this column responds to hover events.
   */
  hoverable: _react.PropTypes.bool,
  /** @ignore */
  onClick: _react.PropTypes.func,
  /** @ignore */
  onHover: _react.PropTypes.func,
  /**
   * @ignore
   * Callback function for hover exit event.
   */
  onHoverExit: _react.PropTypes.func,
  /**
   * Override the inline-styles of the root element.
   */
  style: _react.PropTypes.object
};
TableRowColumn.defaultProps = {
  hoverable: false
};
TableRowColumn.contextTypes = {
  muiTheme: _react.PropTypes.object.isRequired
};
exports.default = TableRowColumn;

/**
 * 文本编辑框
 */

var EditTextField = function (_React$Component) {
  _inherits(EditTextField, _React$Component);

  function EditTextField(props) {
    _classCallCheck(this, EditTextField);

    var _this2 = _possibleConstructorReturn(this, (EditTextField.__proto__ || Object.getPrototypeOf(EditTextField)).call(this, props));

    _this2.state = {
      value: _this2.props.value
    };

    _this2.onBlur = function (event) {
      if (_this2.state.errorText) {
        return;
      }
      // if(!isNaN(value)&&value!==''){
      //  value = Number(value);
      // }
      _this2.props.handleOnBlur(_this2.state.value);
    };

    _this2.onChange = function (event, newValue) {
      if (_this2.props.onChange) {
        var obj = _this2.props.onChange(newValue);
        if (obj.success) {
          _this2.setState({
            errorText: '',
            errorStyle: {}
          });
        } else {
          _this2.setState({
            errorText: obj.errorText,
            errorStyle: obj.errorStyle
          });
        }
      }
      _this2.setState({
        value: newValue
      });
    };

    return _this2;
  }

  /**
   * 文本框失去焦点
   * @param  {[type]} event [description]
   * @return {[type]}       [description]
   */


  /**
   * 获取文本框值
   * @param  {[type]} event    [description]
   * @param  {[type]} newValue [description]
   * @return {[type]}          [description]
   */


  _createClass(EditTextField, [{
    key: 'render',
    value: function render() {
      return _react2.default.createElement(_TextField2.default, {
        name: 'textValue',
        autoFocus: true,
        style: { width: '100%', fontSize: 13 },
        value: this.state.value,
        onBlur: this.onBlur,
        onChange: this.onChange,
        errorText: this.state.errorText,
        errorStyle: this.state.errorStyle
      });
    }
  }]);

  return EditTextField;
}(_react2.default.Component);